# encoding: utf-8
from scipy.optimize import leastsq
import procesa
import math
import sys

n = len( sys.argv )
if n != 2 :
	print "Args: n"
	sys.exit(1)

n = int( sys.argv[1] )

Xiori = [[ 1.0, 2.0, 5.0, 7.0, 9.0, 3.0, 6.0, 8.0],
     [ 7.0, 6.0, 8.0, 7.0, 5.0, 7.0, 2.0, 4.0] ]

if n == 1 :
	va = [ 4.840, 4.797, 3.391, 3.391, 0.0 ]
elif n == 2 :
	va = [ 4.840, 4.797, 3.391, 3.391/2.0, 0.0 ]
elif n == 3 :
	va = [ 4.840, 4.797, 3.391, 3.391/2.0, -1.211 ]
else :
	va = [ 4.918, 5.006, 3.880, 2.896, -0.224 ]

n = len( Xiori[0] )
Xi = [0.0]*2*n

i = 0
while i < n :
 	j = 2*i
 	Xi[j] = Xiori[0][i]
 	Xi[j+1] = Xiori[1][i]
 	# print Xiori[0][i], Xiori[1][i]
 	i += 1
# print

Xx = [ 0.0 ]*2*n
Xo = [ 0.0 ]*2*n

def func( va, E, S1, S2 ) :

	procesa.cambia( E, S1, va )

	n = len( E )/2

	procesa.calcula_puntos_sobre_elipse( S1, S2, va )
	
	procesa.regresa( S2, S1, va )

	# i = 0
	# while i < n :
	# 	print Xe[0][i], Xe[1][i]
	# 	i += 1
	e = [0.0]*2*n
	i = 0
	while i < n :
		j = 2*i
		e[j] = S1[j] - E[j]
		e[j+1] = S1[j+1] - E[j+1]
	 	i += 1

	return( e )

x, COV, info_dict, mesg, ier = leastsq( func, va, args=(Xi, Xx, Xo), full_output=1 )
# x, COV, info_dict, mesg, ier = leastsq( func, va, args=(Xi, Xx, Xo), full_output=1, factor=1 )
# x, ier = leastsq( func, va, args=(Xi, Xx, Xo) )
print "Evaluaciones función objetivo:", info_dict[ "nfev"]
print "Sol:", x
print mesg, ier

err = info_dict[ "fvec" ]
n = len( err )
suma = 0
i = 0
while i < n :
	suma += err[i]*err[i]
	i += 1

print "var:", suma, "sigma:", math.sqrt(suma)
print "sigma_0:", suma
print "Covarianzas:"
i = 0
while i < 5 :
	c = suma*COV[i][i]/11.0  # 11 = 16 - 5 
	print i, c, math.sqrt(c) 
	i += 1

# print Xi
# print Xx
